;------------------------------------------------------------
;------------------------------------------------------------
;------------------------------------------------------------
;
; NAME: get_fullmesh.pro
;
; PURPOSE: Enables getting the full mesh for longitude & latitude
;
; CATEGORY : Subroutine
;
; CALLING SEQUENCE : get_fullmesh, glamt_full,gphit_full
;
; INPUTS :
;         A meshmask file
; OUTPUTS :
;         Longitude and latitude fields that include extra stripes
; COMMON BLOCKS:
;         None
;
; SIDE EFFECTS:
;
; RESTRICTIONS:
;
; EXAMPLE:
;
; MODIFICATION HISTORY: 08/2002 Robinson Hordoir
;
;------------------------------------------------------------
;------------------------------------------------------------
;------------------------------------------------------------

pro get_fullmesh, glamt_full,gphit_full

@initorca_grand

glamt_full=glamt
gphit_full=gphit

@initorca


end

